// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from caret_msgs:msg/Start.idl
// generated code does not contain a copyright notice

#ifndef CARET_MSGS__MSG__DETAIL__START__TRAITS_HPP_
#define CARET_MSGS__MSG__DETAIL__START__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "caret_msgs/msg/detail/start__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace caret_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Start & msg,
  std::ostream & out)
{
  out << "{";
  // member: recording_frequency
  {
    out << "recording_frequency: ";
    rosidl_generator_traits::value_to_yaml(msg.recording_frequency, out);
    out << ", ";
  }

  // member: ignore_nodes
  {
    out << "ignore_nodes: ";
    rosidl_generator_traits::value_to_yaml(msg.ignore_nodes, out);
    out << ", ";
  }

  // member: ignore_topics
  {
    out << "ignore_topics: ";
    rosidl_generator_traits::value_to_yaml(msg.ignore_topics, out);
    out << ", ";
  }

  // member: select_nodes
  {
    out << "select_nodes: ";
    rosidl_generator_traits::value_to_yaml(msg.select_nodes, out);
    out << ", ";
  }

  // member: select_topics
  {
    out << "select_topics: ";
    rosidl_generator_traits::value_to_yaml(msg.select_topics, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Start & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: recording_frequency
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "recording_frequency: ";
    rosidl_generator_traits::value_to_yaml(msg.recording_frequency, out);
    out << "\n";
  }

  // member: ignore_nodes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ignore_nodes: ";
    rosidl_generator_traits::value_to_yaml(msg.ignore_nodes, out);
    out << "\n";
  }

  // member: ignore_topics
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ignore_topics: ";
    rosidl_generator_traits::value_to_yaml(msg.ignore_topics, out);
    out << "\n";
  }

  // member: select_nodes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "select_nodes: ";
    rosidl_generator_traits::value_to_yaml(msg.select_nodes, out);
    out << "\n";
  }

  // member: select_topics
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "select_topics: ";
    rosidl_generator_traits::value_to_yaml(msg.select_topics, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Start & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace caret_msgs

namespace rosidl_generator_traits
{

[[deprecated("use caret_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const caret_msgs::msg::Start & msg,
  std::ostream & out, size_t indentation = 0)
{
  caret_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use caret_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const caret_msgs::msg::Start & msg)
{
  return caret_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<caret_msgs::msg::Start>()
{
  return "caret_msgs::msg::Start";
}

template<>
inline const char * name<caret_msgs::msg::Start>()
{
  return "caret_msgs/msg/Start";
}

template<>
struct has_fixed_size<caret_msgs::msg::Start>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<caret_msgs::msg::Start>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<caret_msgs::msg::Start>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // CARET_MSGS__MSG__DETAIL__START__TRAITS_HPP_
