// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from caret_msgs:msg/Status.idl
// generated code does not contain a copyright notice

#ifndef CARET_MSGS__MSG__DETAIL__STATUS__TRAITS_HPP_
#define CARET_MSGS__MSG__DETAIL__STATUS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "caret_msgs/msg/detail/status__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace caret_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Status & msg,
  std::ostream & out)
{
  out << "{";
  // member: caret_node_name
  {
    out << "caret_node_name: ";
    rosidl_generator_traits::value_to_yaml(msg.caret_node_name, out);
    out << ", ";
  }

  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: node_names
  {
    if (msg.node_names.size() == 0) {
      out << "node_names: []";
    } else {
      out << "node_names: [";
      size_t pending_items = msg.node_names.size();
      for (auto item : msg.node_names) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: pid
  {
    out << "pid: ";
    rosidl_generator_traits::value_to_yaml(msg.pid, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Status & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: caret_node_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "caret_node_name: ";
    rosidl_generator_traits::value_to_yaml(msg.caret_node_name, out);
    out << "\n";
  }

  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: node_names
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.node_names.size() == 0) {
      out << "node_names: []\n";
    } else {
      out << "node_names:\n";
      for (auto item : msg.node_names) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: pid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pid: ";
    rosidl_generator_traits::value_to_yaml(msg.pid, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Status & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace caret_msgs

namespace rosidl_generator_traits
{

[[deprecated("use caret_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const caret_msgs::msg::Status & msg,
  std::ostream & out, size_t indentation = 0)
{
  caret_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use caret_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const caret_msgs::msg::Status & msg)
{
  return caret_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<caret_msgs::msg::Status>()
{
  return "caret_msgs::msg::Status";
}

template<>
inline const char * name<caret_msgs::msg::Status>()
{
  return "caret_msgs/msg/Status";
}

template<>
struct has_fixed_size<caret_msgs::msg::Status>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<caret_msgs::msg::Status>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<caret_msgs::msg::Status>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // CARET_MSGS__MSG__DETAIL__STATUS__TRAITS_HPP_
